Handle post actions

Report designing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Designer Web API service. It allows you to set additional headers, custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property

   <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner({
                    serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI",
                    ajaxBeforeLoad: "onAjaxRequest"
                });
            });

        function onAjaxRequest(args) {
            args.headers.push({ Key: 'Authorization' });
        }
    </script>

You can view the Web API service used in the above code from the Reporting Service git hub location. For more information, see Samples and demos.

Get the custom header value from the HttpContext header collection using the key name specified at client-side.

        string authenticationHeader;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, custom data values are passed to the server-side.

 <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner({
                    serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI",
                    ajaxBeforeLoad: "onAjaxRequest"
                });
            });

        function onAjaxRequest(args) {
             //Passing custom data to server
                var customerID = "CI0021";
                args.data = customerID;
        }
    </script>

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates how to store the custom data values.

        string customerID = null;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {

            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    customerID = jsonResult["customData"].ToString();
                }
            }

            return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
        }

Perform your own action to use the custom data values.

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

 <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner({
                    serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI",
                    ajaxBeforeLoad: "onAjaxRequest",
                    ajaxSuccess: "onAjaxSuccess"
                });
            });

        function onAjaxRequest(args) {
            args.headers.push({ Key: 'Authorization', Value: btoa('guest', 'demo@123') });
        }

        function onAjaxSuccess(args) {
                //Perform your custom success message here
                alert("Ajax request success!!!");
        }
    </script>

AjaxError

The ajaxError event is called, if an error occurred with the request, you can display the customized error detail in the event method.

        <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner({
                    serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI",
                    ajaxBeforeLoad: "onAjaxRequest",
                    ajaxError: "onAjaxFailure"
                });
            });

        function onAjaxRequest(args) {
            args.headers.push({ Key: 'Authorization', Value: btoa('guest', 'demo@123') });
        }

        function onAjaxFailure(args) {
                alert("Status: " + args.status + "\n" +
                    "Error: " + args.responseText);
        }
    </script>

You can never have both an error and a success callback with a request.

Handle post actions

Report designing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Designer Web API service. It allows you to set additional headers, custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property

function App() {
  return (
    <div style={designerStyle} className="App">
            <BoldReportDesignerComponent
            id="reportdesigner_container"
            serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
            ajaxBeforeLoad = {onAjaxRequest}>
            </BoldReportDesignerComponent>
    </div>
  );
}
  
function onAjaxRequest(event) {
    event.headers.push({
    Key: 'Authorization', Value: 'demo@123'
    });
}

Get the custom header value from the HttpContext header collection using the key name specified at client-side.

        string authenticationHeader;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, custom data values are passed to the server-side.

function App() {
  return (
    <div style={designerStyle} className="App">
            <BoldReportDesignerComponent
            id="reportdesigner_container"
            serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
            ajaxBeforeLoad = {onAjaxRequest}>
            </BoldReportDesignerComponent>
    </div>
  );
}
  
function onAjaxRequest(event) {
    //Passing custom data to server
    var customerID = "CI0021";
    event.data = customerID;
}

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates how to store the custom data values.

        string customerID = null;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {

            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    customerID = jsonResult["customData"].ToString();
                }
            }

            return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
        }

Perform your own action to use the custom data values.

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

function App() {
  return (
    <div style={designerStyle} className="App">
            <BoldReportDesignerComponent
            id="reportdesigner_container"
            serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
            ajaxSuccess = {onAjaxSuccess}>
            </BoldReportDesignerComponent>
    </div>
  );
}

function onAjaxSuccess(event) {
    //Perform your custom success message here
    alert("Ajax request success!!!");
}

AjaxError

The ajaxError event is called, if an error occurred with the request, you can display the customized error detail in the event method.

function App() {
  return (
    <div style={designerStyle} className="App">
            <BoldReportDesignerComponent
            id="reportdesigner_container"
            serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
            ajaxError = {onAjaxFailure}>
            </BoldReportDesignerComponent>
    </div>
  );
}

function onAjaxFailure(event) {
    alert("Status: " + event.status + "\n" +
            "Error: " + event.responseText);
}

You can never have both an error and a success callback with a request.

Handle post actions

Report designing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Designer Web API service. It allows you to set additional headers, custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property

<bold-reportdesigner id="designer"
    [serviceUrl] = "serviceUrl"
    style="position: absolute;height: 550px; width: 1250px;"
    (ajaxBeforeLoad) = "onAjaxRequest($event)">
</bold-reportdesigner>
import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'reportdesignerapp';
  public serviceUrl: string;

    constructor() {
        this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
    }

    onAjaxRequest(event) {
         event.headers.push({ Key: 'Authorization', Value: 'demo@123' });
    }
}

Get the custom header value from the HttpContext header collection using the key name specified at client-side.

        string authenticationHeader;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, custom data values are passed to the server-side.

<bold-reportdesigner id="designer"
    [serviceUrl] = "serviceUrl"
    style="position: absolute;height: 550px; width: 1250px;"
    (ajaxBeforeLoad) = "onAjaxRequest($event)">
</bold-reportdesigner>
import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'reportdesignerapp';
  public serviceUrl: string;

    constructor() {
        this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
    }

    onAjaxRequest(event) {
        //Passing custom data to server
        var customerID = "CI0021";
        event.data = customerID;
    }
}

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates how to store the custom data values.

        string customerID = null;

        public object PostDesignerAction(Dictionary<string, object> jsonResult)
        {

            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    customerID = jsonResult["customData"].ToString();
                }
            }

            return ReportDesignerHelper.ProcessDesigner(jsonResult, this, null);
        }

Perform your own action to use the custom data values.

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

<bold-reportdesigner id="designer"
    [serviceUrl] = "serviceUrl"
    style="position: absolute;height: 550px; width: 1250px;"
    (ajaxSuccess) = "onAjaxSuccess($event)">
</bold-reportdesigner>
import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'reportdesignerapp';
  public serviceUrl: string;

    constructor() {
        this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
    }

    onAjaxSuccess(event) {
        //Perform your custom success message here
        alert("Ajax request success!!!");
    }
}

AjaxError

The ajaxError event is called, if an error occurred with the request, you can display the customized error detail in the event method.

<bold-reportdesigner id="designer"
    [serviceUrl] = "serviceUrl"
    style="position: absolute;height: 550px; width: 1250px;"
    (ajaxError) = "onAjaxFailure($event)">
</bold-reportdesigner>
import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'reportdesignerapp';
  public serviceUrl: string;

    constructor() {
        this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
    }

    onAjaxFailure(event) {
        alert("Status: " + event.status + "\n" +
                    "Error: " + event.responseText);
    }
}

You can never have both an error and a success callback with a request.